import datetime
import numpy as np
from collections import deque

class Status:
    def __init__(self, name, n, navg=100, report_percentage=1.0):
        self.name               = name
        self.i                  = 0
        self.n                  = n

        self.navg               = navg
        self.report_percentage  = report_percentage

        self.t                  = deque( [ datetime.datetime.now() ] )

    def iterate(self):
        self.i                 += 1
        self.t.append(datetime.datetime.now())

        if len(self.t) > self.navg:
            nul = self.t.popleft()
        
        tstep_percent = 1/self.n * 100.0
    #    if ( (i * tstep_percent) % (tstep_percent * report_percentage) ) <= tstep_percent:

        avg_dt = np.sum ( np.diff(self.t) ) / len(self.t) if len(self.t) > 1 else datetime.timedelta(seconds=1)
        print("{:s}: {:d} of {:d} ({:3.0f}%, {:7.0f} seconds left)".format(self.name, self.i+1, self.n, self.i/self.n*100, avg_dt.total_seconds() * (self.n-self.i) ))
